'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _fs = require('fs');

var _babelCore = require('babel-core');

var _path = require('path');

var _lodash = require('lodash');

var _mkdirp = require('mkdirp');

var _broccoliPlugin = require('broccoli-plugin');

var _broccoliPlugin2 = _interopRequireDefault(_broccoliPlugin);

var _walkSync = require('walk-sync');

var _walkSync2 = _interopRequireDefault(_walkSync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Babel = function (_Plugin) {
  _inherits(Babel, _Plugin);

  function Babel(inputNodes) {
    var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    _classCallCheck(this, Babel);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Babel).call(this, (0, _lodash.isArray)(inputNodes) ? inputNodes : [inputNodes], {
      annotation: options.annotation
    }));

    _this.options = options;
    return _this;
  }

  _createClass(Babel, [{
    key: 'build',
    value: function build() {
      var srcDir = this.inputPaths[0];

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _walkSync2.default)(srcDir)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var filename = _step.value;

          if (filename.slice(-3) !== '.js') {
            continue;
          }

          var output = (0, _babelCore.transformFileSync)(srcDir + '/' + filename, this.options);
          var outputFilename = this.outputPath + '/' + filename;

          (0, _mkdirp.sync)((0, _path.dirname)(outputFilename));

          (0, _fs.writeFileSync)(outputFilename, output.code);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }]);

  return Babel;
}(_broccoliPlugin2.default);

exports.default = Babel;
module.exports = exports['default'];